/*
 *	acpxpk - ACPXPK01WJ[eBeB
 *
 *	"ACPXPK01"`̃A[JCuWJ邽߂̃c[łB
 *	wVgv}F[uxBGMo߂ɍ܂B
 *
 *	lNSN̉yĩt@ŁA(Ƃ݃A^bNƂ}GƂɂłˁ[)
 *	v}F[uNSN̎̉yƎvĔĂ݂NSNȂ`
 *	u(X~}Z!)̂łAĂ݂ƃ`[T{V̉yłˁB
 *	WXƂȒȂȂByP̂ły߂܂BƂ킯ŁEEE
 *
 *	GXN[h̃Q[BGM CDDÂ̂̂łÃQ[OggVorbisłB
 *	ƂĂȒPȃA[JCu`Ȃ̂ŁAƂŎoĂقǎԂ͂ȂłǁA
 *	ꉞAopc[Ă݂܂B
 *
 *	Copyright (C) 2004 Naoyuki Sawa
 *
 *	* Sat Jan 03 19:31:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define VERSION		"20040103"

const char* APPNAME;
const char* ARCHIVE;

typedef struct _HEADER {
	char fname[32];		/* t@C */
	int offset;		/* t@CJnʒu(A[JCuΈʒu) */
	int size;		/* t@CTCY */
} HEADER;

void
usage()
{
	printf("acpxpk - ACPXPK01WJ[eBeB (%s)\n", VERSION);
	printf("USAGE:\n");
	printf("\t%s <A[JCut@C>\n", APPNAME);
	printf("EXAMPLE:\n");
	printf("\t%s \"C:\\Program Files\\GXN[h\\Vgv}F[u\\BGM.bin\"\n", APPNAME);
	exit(-1);
}

int
main(int argc, char* argv[])
{
	int retval;
	FILE *fp_in, *fp_out;
	char signature[8];
	int count, i;
	HEADER header;
	fpos_t pos;
	void* buf;

	APPNAME = argv[0];
	if(argc != 1 + 1) usage();
	ARCHIVE = argv[1];

	fp_in = fopen(ARCHIVE, "rb");
	if(!fp_in) {
		printf("### %s J܂B\n", ARCHIVE);
		exit(-1);
	}

	retval = fread(signature, 1, sizeof signature, fp_in);
	if(retval != sizeof signature || memcmp(signature, "ACPXPK01", sizeof signature) != 0) {
		printf("### signature G[\n");
		exit(-1);
	}

	retval = fread(&count, 1, sizeof count, fp_in);
	if(retval != sizeof count || count <= 0) {
		printf("### count G[\n");
		exit(-1);
	}

	for(i = 0; i < count; i++) {
		retval = fread(&header, 1, sizeof header, fp_in);
		if(retval != sizeof header) {
			printf("### header G[\n");
			exit(-1);
		}
		printf("#%d: %s offset=%d size=%d\n", i, header.fname, header.offset, header.size);

/*{{1*/		retval = fgetpos(fp_in, &pos);
		if(retval != 0) {
			printf("### fgetpos G[\n");
			exit(-1);
		}

		retval = fseek(fp_in, header.offset, SEEK_SET);
		if(retval != 0) {
			printf("### fseek G[\n");
			exit(-1);
		}

/*{{2*/		buf = malloc(header.size);
		if(!buf) {
			printf("### malloc G[\n");
			exit(-1);
		}

		retval = fread(buf, 1, header.size, fp_in);
		if(retval != header.size) {
			printf("### fread G[\n");
			exit(-1);
		}

/*{{3*/		fp_out = fopen(header.fname, "wb");
		if(!fp_out) {
			printf("### %s 쐬ł܂B\n", header.fname);
			exit(-1);
		}

		retval = fwrite(buf, 1, header.size, fp_out);
		if(retval != header.size) {
			printf("### fwrite G[\n");
			exit(-1);
		}

/*}}3*/		fclose(fp_out);

/*}}2*/		free(buf);

/*}}1*/		retval = fsetpos(fp_in, &pos);
		if(retval != 0) {
			printf("### fsetpos G[\n");
			exit(-1);
		}
	}

	printf("OK\n");
	getchar();

	return 0;
}
